/*
	Amazon Search
	Copyright (c) 2005 Edward Anastas - Some rights reserved
	http://www.wishcentral.com/
*/

// global request and XML document objects
var req;

//var currentVersion;
var currentVersion = getKeyValue("info.plist", "CFBundleVersion");
var updatePositionOpen;
var udpate = new Array;


// retrieve XML document (reusable generic function);
// parameter is URL string (relative or complete) to
// an .xml file whose Content-Type is a valid XML
// type, such as text/xml; XML source must be from
// same domain as HTML file
function checkVersion() {
	
	url = "http://wishcentral.com/dashboard/amazonsearch/AmazonSearch.xml";
	
	// branch for native XMLHttpRequest object
	if (window.XMLHttpRequest) {
		req = new XMLHttpRequest();
		req.onreadystatechange = processVersionData;
		req.open("GET", url, true);
		req.send();
		// branch for IE/Windows ActiveX version
	} else if (window.ActiveXObject) {
		isIE = true;
		req = new ActiveXObject("Microsoft.XMLHTTP");
		if (req) {
			req.onreadystatechange = processVersionData;
			req.open("GET", url, true);
			req.send();
		}
	}
}

function processVersionData() {
	
	if ( req.readyState == 4 ) { // if request completed
		
		var versionData = req.responseXML.getElementsByTagName("widget")[0];
		
		udpate['title'] = versionData.getElementsByTagName("title").item(0).firstChild.nodeValue;
		udpate['link'] = versionData.getElementsByTagName("link").item(0).firstChild.nodeValue;
		udpate['version'] = versionData.getElementsByTagName("version").item(0).firstChild.data;
		
		//document.getElementById('keyword').setAttribute('placeholder', 'udpateVersion: ' + udpate['Version']);
		
		if ( currentVersion < udpate['version']) {
			
			showUpdate(udpate);
			//widget.system("/usr/bin/osascript -e 'say \"this is the Amazon Search Widget auto-update, version "+ udpate['version'] +" is available, you currently have version "+ currentVersion +", would you like to download the new version?\" using \"Victoria\"'" , null); //Zarvox //Victoria
			
		}
		
		
		
	} else {
		if ( window.widget ) {
			//document.getElementById('keyword').setAttribute('placeholder', 'status: ' + req.statusText + " ("+ req.readyState +")");
		} else {
			alert("There was a problem retrieving the XML data:\n" +
				req.statusText);
		}
	}
}

function showUpdate(udpate) {
	
	toggleUpdate(); // show autoUpdate before stretch
	
	stretcher = new Stretcher(document.getElementById('front'), 40, 400, changeToggleStatus); // hide autoUpdate after stretch finishes
	
	stretcher.stretch(event);
	
	updateVersionText.innerText = "Version "+ udpate['version'] +" is available!";
	currentVersionText.innerText = "(you currently have version "+ currentVersion +")";
	// stop loading setup
	break;
	
}


function hideUpdate() {
	
	stretcher.stretch(event);
	
}


function changeToggleStatus() {
	
	if ( !updatePositionOpen ) {
		updatePositionOpen = true;
	} else {
		toggleUpdate();
		stretcher = new Stretcher(document.getElementById('front'), 30, 400, changeText);
	}
	
}

function toggleUpdate() {
	
	if ( !updatePositionOpen ) { // open updater
		var toggleMain = "hidden";
		var toggleUpdate = "visible";
	} else { // close updater
		var toggleMain = "visible";
		var toggleUpdate = "hidden";
	}
	
	document.getElementById("logo").style.visibility = toggleMain;
	document.getElementById("keyword").style.visibility = toggleMain;
	document.getElementById("selectMenu").style.visibility = toggleMain;
	
	document.getElementById("autoUpdateTitle").style.visibility = toggleUpdate;
	document.getElementById("autoUpdateBottom").style.visibility = toggleUpdate;
	document.getElementById("autoUpdateTop").style.visibility = toggleUpdate;
	document.getElementById("updateNoteText").style.visibility = toggleUpdate;
	
}

// much appreciation for the following function
// this code submitted by Chris from dashboardwidgets.com Thanks!
// http://www.dashboardwidgets.com/forums/viewtopic.php?t=689
function getKeyValue(plist, key) {
	
	var infoPlist = new XMLHttpRequest();
	infoPlist.open("GET", plist, false);
	infoPlist.send(null);
	
	
	//var xml = infoPlist.responseXML.getElementsByTagName("dict");
	
	var xml = infoPlist.responseXML;
	var keys = xml.getElementsByTagName("key");
	var vals = xml.getElementsByTagName("string");
	var key_value;
	
	//for (var i in se) { // future implementation
	for (var i=0; i < keys.length; i++) {
		if (keys[i].firstChild.data == key) {
			key_value = vals[i].firstChild.data;
			break;
		}
	}
	//infoPlist.abort(null);
	return key_value;
}

function downloadUpdate() {
	
	// remove current widget before downloading (be sure to set the info.plist access correctly)
	widget.system("mv ~/Library/Widgets/AmazonSearch.wdgt ~/.Trash/AmazonSearch_" + currentVersion + ".wdgt", null);
	
	//stretcher.stretch(event);
	
	if ( udpate['link'].length < 1 ) {
		url = "http://www.wishcentral.com/dashboard/amazonsearch/?autoupdate=1";
	} else {
		url = udpate['link'];
	}
	
	wrapURL(url);
	
}
